#
# Various redundant functions that interact with the DBI
#
# $Id: sql-attach.pl,v 1.9 2000/06/26 18:31:43 nemesis Exp $
#
# Copyright (C) 2000 Cornelius Cook
# cook@cpoint.net, http://collective.cpoint.net/
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
# http://www.gnu.org/copyleft/gpl.html

# This file is used to do various regular things wrt the SQL server
use DBI;

#$DEBUG=1;

$SQL_driver = "mysql";
$SQL_database="Imagez";
$SQL_dsn = "DBI:$SQL_driver:$SQL_database";
$SQL_user = "USER";
$SQL_password = "PASSWORD";

sub ProcessQuery {
	my($query) = shift @_;
	my($extra)=join(" ",@_);

	if (-f $query) {
       		$query=`grep -v ^# $query`;
        	$query=~s/\n/ /g;
	}
        if ($extra ne "") {
               	if ($query =~ /\swhere\s/i) {
                       	$query =~ s/\swhere\s/ WHERE ( $extra ) AND /i;
               	}
               	else {
                       	if ($query=~/(\s(order|group)\sby\s)/i) {
                               	$query=$`." WHERE $extra ".$1.$';
                       	}
                       	else {
                               	$query.=" WHERE $extra";
                       	}
               	}
        }
	$query;
}

# return a single value from a query
sub GetScalar {
	my($dbh,$query)=@_;

	GetScalarSTH(GetSTH($dbh,$query));
}

sub GetScalarSTH {
	my($sth)=@_;

	@result=GetListSTH($sth);
	$result[0];
}

# Returns a simple list based on a query
sub GetSTH {
	my($dbh,$query)=@_;

	warn "QUERY being executed:\n$query\n" if ($DEBUG);

	my $sth = $dbh->prepare($query);	
	my $rc  = $sth->execute();
	$sth;
}

sub GetList {
	my($dbh,$query)=@_;

	GetListSTH(GetSTH($dbh,$query));
}

sub GetListSTH {
	my($sth)=@_;
	my(@result,$rc,@fields);

	while (@fields = $sth->fetchrow_array) {
		push(@result,join("",@fields));
	}
	@result;
}

sub GetCols {
	my($dbh,$query)=@_;
	my($sth,@result,$rc,@fields);
	
	$sth = $dbh->prepare($query);	
	$rc  = $sth->execute;
	@fields = $sth->fetchrow_array;
	@result=@fields;
}

sub GetFirst {
	my($dbh,$query)=@_;
	my(@result);
	@result=GetCols($dbh,$query);
	$result[0];
}

sub GetHash {
	my($dbh,$query)=@_;
	my($sth,%result,$rc,@fields,@names);

	$sth = $dbh->prepare($query);
	$rc  = $sth->execute;

	@names=@{ $sth->{NAME} };
	@fields=$sth->fetchrow_array;

	foreach (@names) {
		$result{$_}=shift @fields;
	}
	%result;
}

sub GetDoubleWithFields {
	my($dbh,$query)=@_;

	GetDoubleWithFieldsSTH(GetSTH($dbh,$query));
}

sub GetDoubleWithFieldsSTH {
	my($sth)=@_;
	my($result,@fields);

	push(@$result,[ @{ $sth->{NAME} } ]);
	if ($sth->{NAME}) {
	while (@fields = $sth->fetchrow_array) {
		push(@$result,[ @fields ]);
	}
	}

	$result;
}

sub GetDouble {
	my($dbh,$query) = @_;
	my($result);

	$result=GetDoubleWithFields($dbh,$query);

	shift(@{$result});

	$result;
}


# uses the %format hash list:
# but they each get eval'd after the query
# The title string
# 	$format->{TITLE}
# How to format each line
# 	$format->{LINE}
# Top, Bottom strings
#	$format->{TOP}
#	$format->{BOTTOM}
sub GetTable {
	my($dbh,$query,$format)=@_;
	my($sth,$result,$rc,@fields);
	my($top,$title,$line,$bottom);

	#print "$query\n";

	$sth = $dbh->prepare($query);	
	$rc  = $sth->execute;

	eval("\$line=$format->{LINE}");	
	eval("\$title=$format->{TITLE}");	
	eval("\$top=$format->{TOP}");	
	eval("\$bottom=$format->{BOTTOM}");	

	$result=$top.$title;

	while (@fields = $sth->fetchrow_array) {
		$result.=sprintf($line,@fields);
	}
	$result.=$bottom;
	$result;
}


sub PrettyQuery {
	my($dbh,$query)=@_;

	PrettyDumpSTH(GetSTH($dbh,$query));
}

sub BlankPrettyQuery {
	my($dbh,$query)=@_;

	PrettyDumpSTH(GetSTH($dbh,$query),1);
}

sub PrettyDumpSTH {
	my($sth,$blankrepeats)=@_;

	PrettyDumpDouble(GetDoubleWithFieldsSTH($sth),$blankrepeats);
}

sub PrettySprintfSTH {
	my($sth,$blankrepeats)=@_;

	PrettySprintfDouble(GetDoubleWithFieldsSTH($sth),$blankrepeats);
}

sub PrettyDumpDouble {
	print PrettySprintfDouble(@_);
}

sub PrettySprintfDouble {
	my($list,$blankrepeats,$separator_row)=@_;
	my($separator,$piece);
	my(@list,$field,$size,@sizes,$text,$fieldlen,$line,$row,@lastrow);
	my($out);

	$out="";

	# Extract the field names
	$field=shift(@{$list});
	my @names=@{$field};

	# nothing returned?
	$idx=$#{$list}+1;
	return if ($idx==0);
	
	# figure out the maximum size of each field by visiting each value
	foreach $field (0 .. $#names) {
		$size=0;
	
		$text=$names[$field];
		$fieldlen=length($text);
		$size=$fieldlen if ($fieldlen>$size);
	
		foreach $line (0 .. ($idx-1)) {
			$text=$list->[$line]->[$field];
			$fieldlen=length($text);
			$size=$fieldlen if ($fieldlen>$size);
		}
		push(@sizes,$size);
	}
	
	# print a pretty table including field names
	undef @lastrow;
	foreach $row (-3 .. $idx) {
		$line="";
		$queue="";
		if ($row==-3 || $row==-1 || $row==$idx) {
			$piece="+";
			$separator=$piece;
			$line.=$piece;
		}
		else {
			$line.="|";
			$queue=$separator;
		}
	
		foreach $field (0 .. $#names) {
			if ($row < 0 || $row==$idx) {
				if ($row!=-2) {
					$piece= "-" x ($sizes[$field]+2) . "+";
					$separator.=$piece;
					$line.= $piece;
				}
				else {
					$line.=sprintf(" %-$sizes[$field]s |",$names[$field]);
				}
			}
			else {
				$text=$list->[$row]->[$field];
				if ($blankrepeats && $text eq $lastrow[$field]) {
					$text=" \" \" " if ($text ne "");
					$queue="" if ($field==$separator_row);
				}
				else {
					$lastrow[$field]=$text;
					$queue.="\n" if ($field==$separator_row);
				}
				$minus="";
				$minus="-" if ($text !~ /^-?[\d,]*\.?\d+$/);
				$line.=sprintf(" %${minus}$sizes[$field]s |",$text);
			}
		}
		$queue="" if (!defined($separator_row) ||
					$separator_row<0 ||
					$separator_row>$#names ||
					$row<1 || $row>=$idx);

		$out.="${queue}${line}\n";
	}
	$out;
}	
